Summary: The GNOME Display Manager
Name:    gdm
Version: 41.3
Release: 7%{?dist}
License: GPLv2+
URL:     https://wiki.gnome.org/Projects/GDM
Source0: http://download.gnome.org/sources/gdm/41/gdm-%{version}.tar.xz
Source1: org.gnome.login-screen.gschema.override
Source2: default.pa-for-gdm
Source3: gdm.sysusers
Source4: gdm-autologin.pam
Source5: gdm-fingerprint.pam
Source6: gdm-launch-environment.pam
Source7: gdm-password.pam
Source8: gdm-smartcard.pam

Patch3000: 0001-gdm.rules-Prefer-Wayland-with-NVIDIA-510.patch
Patch3001: 0001-Honor-initial-setup-being-disabled-by-distro-install.patch
Patch3002: 0001-data-add-system-dconf-databases-to-gdm-profile.patch

BuildRequires: accountsservice-devel audit-libs-devel dconf desktop-file-utils
BuildRequires: gettext-devel git keyutils-libs-devel libXdmcp-devel libattr-devel
BuildRequires: libdmx-devel meson nss-devel pam-devel pkgconfig(accountsservice)
BuildRequires: pkgconfig(check) pkgconfig(gobject-introspection-1.0) pkgconfig(gtk+-3.0)
BuildRequires: pkgconfig(iso-codes) pkgconfig(libcanberra-gtk3) pkgconfig(libselinux)
BuildRequires: pkgconfig(libsystemd) pkgconfig(ply-boot-client) pkgconfig(systemd)
BuildRequires: pkgconfig(x11) pkgconfig(xau) pkgconfig(xorg-server) plymouth-devel
BuildRequires: systemd-rpm-macros which xorg-x11-server-Xorg xorg-x11-server-devel
BuildRequires: yelp-devel yelp-tools

Requires: accountsservice audit-libs dconf gnome-keyring-pam gnome-session
Requires: gnome-session-wayland-session gnome-settings-daemon gnome-shell
Requires: iso-codes libXau pam /sbin/nologin setxkbmap systemd system-logos
Requires: xhost xmodmap xrdb xorg-x11-xinit /usr/bin/dbus-run-session
Requires(pre):    /usr/sbin/useradd

Provides: gdm-libs = %{version}-%{release}
Provides: service(graphical-login) = %{name}

%description
GDM, the GNOME Display Manager, handles authentication-related backend functionality for logging
in a user and unlocking the user's session after it's been locked. GDM also provides functionality
for initiating user-switching, so more than one user can be logged in at the same time. It handles
graphical session registration with the system for both local and remote sessions (in the latter case,
via the XDMCP protocol).  In cases where the session doesn't provide it's own display server, GDM can
start the display server on behalf of the session.

%package devel
Summary: Development files for gdm
Requires: %{name} = %{version}-%{release}
Requires: gdm-pam-extensions-devel = %{version}-%{release}

%description devel
The gdm-devel package contains headers and other
files needed to build custom greeters.

%package pam-extensions-devel
Summary: Macros for developing GDM extensions to PAM
Requires: pam-devel

%description pam-extensions-devel
The gdm-pam-extensions-devel package contains headers and other files that are helpful to PAM modules
wishing to support GDM specific authentication features.

%prep
%autosetup -S git -n gdm-%{version}

%build
%meson -Dpam-prefix=%{_sysconfdir} \
       -Drun-dir=/run/gdm \
       -Dudev-dir=%{_udevrulesdir} \
       -Ddefault-path=/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin \
       -Dprofiling=true \
       -Dplymouth=enabled \
       -Dselinux=enabled \
%meson_build


%install
mkdir -p %{buildroot}%{_sysconfdir}/gdm/Init
mkdir -p %{buildroot}%{_sysconfdir}/gdm/PreSession
mkdir -p %{buildroot}%{_sysconfdir}/gdm/PostSession

%meson_install

install -p -m644 -D %{SOURCE2} %{buildroot}%{_localstatedir}/lib/gdm/.config/pulse/default.pa
install -p -m644 -D %{SOURCE3} %{buildroot}%{_sysusersdir}/%{name}.conf

rm -f %{buildroot}%{_sysconfdir}/pam.d/gdm

cp -a %{SOURCE1} %{buildroot}%{_datadir}/glib-2.0/schemas

rm -rf %{buildroot}/%{_prefix}/doc

mkdir -p %{buildroot}/var/log/gdm

(cd %{buildroot}%{_sysconfdir}/gdm; ln -sf ../X11/xinit/Xsession .)

mkdir -p %{buildroot}%{_datadir}/gdm/autostart/LoginWindow
mkdir -p %{buildroot}/run/gdm
mkdir -p %{buildroot}%{_sysconfdir}/dconf/db/gdm.d/locks

# install pam config files
install -p -m644 -D %{SOURCE4} %{buildroot}%{_sysconfdir}/pam.d/gdm-autologin
install -p -m644 -D %{SOURCE5} %{buildroot}%{_sysconfdir}/pam.d/gdm-fingerprint
install -p -m644 -D %{SOURCE6} %{buildroot}%{_sysconfdir}/pam.d/gdm-launch-environment
install -p -m644 -D %{SOURCE7} %{buildroot}%{_sysconfdir}/pam.d/gdm-password
install -p -m644 -D %{SOURCE8} %{buildroot}%{_sysconfdir}/pam.d/gdm-smartcard

%find_lang gdm --with-gnome

%pre
%sysusers_create_compat %{SOURCE3}

%post
custom=/etc/gdm/custom.conf

if [ $1 -ge 2 ] ; then
    if [ -f /usr/share/gdm/config/gdm.conf-custom ]; then
        oldconffile=/usr/share/gdm/config/gdm.conf-custom
    elif [ -f /etc/X11/gdm/gdm.conf ]; then
        oldconffile=/etc/X11/gdm/gdm.conf
    fi

    [ -n "$oldconffile" ] && sed \
    -e 's@^command=/usr/X11R6/bin/X@#command=/usr/bin/Xorg@' \
    -e 's@^Xnest=/usr/X11R6/bin/Xnest@#Xnest=/usr/X11R6/bin/Xnest@' \
    -e 's@^BaseXsession=/etc/X11/xdm/Xsession@#BaseXsession=/etc/X11/xinit/Xsession@' \
    -e 's@^BaseXsession=/etc/X11/gdm/Xsession@#&@' \
    -e 's@^BaseXsession=/etc/gdm/Xsession@#&@' \
    -e 's@^Greeter=/usr/bin/gdmgreeter@#Greeter=/usr/libexec/gdmgreeter@' \
    -e 's@^RemoteGreeter=/usr/bin/gdmlogin@#RemoteGreeter=/usr/libexec/gdmlogin@' \
    -e 's@^GraphicalTheme=Bluecurve@#&@' \
    -e 's@^BackgroundColor=#20305a@#&@' \
    -e 's@^DefaultPath=/usr/local/bin:/usr/bin:/bin:/usr/X11R6/bin@#&@' \
    -e 's@^RootPath=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/usr/X11R6/bin@#&@' \
    -e 's@^HostImageDir=/usr/share/hosts/@#HostImageDir=/usr/share/pixmaps/faces/@' \
    -e 's@^LogDir=/var/log/gdm@#&@' \
    -e 's@^PostLoginScriptDir=/etc/X11/gdm/PostLogin@#&@' \
    -e 's@^PreLoginScriptDir=/etc/X11/gdm/PreLogin@#&@' \
    -e 's@^PreSessionScriptDir=/etc/X11/gdm/PreSession@#&@' \
    -e 's@^PostSessionScriptDir=/etc/X11/gdm/PostSession@#&@' \
    -e 's@^DisplayInitDir=/var/run/gdm.pid@#&@' \
    -e 's@^RebootCommand=/sbin/reboot;/sbin/shutdown -r now;/usr/sbin/shutdown -r now;/usr/bin/reboot@#&@' \
    -e 's@^HaltCommand=/sbin/poweroff;/sbin/shutdown -h now;/usr/sbin/shutdown -h now;/usr/bin/poweroff@#&@' \
    -e 's@^ServAuthDir=/var/gdm@#&@' \
    -e 's@^Greeter=/usr/bin/gdmlogin@Greeter=/usr/libexec/gdmlogin@' \
    -e 's@^RemoteGreeter=/usr/bin/gdmgreeter@RemoteGreeter=/usr/libexec/gdmgreeter@' \
    $oldconffile > $custom
fi

if [ $1 -ge 2 -a -f $custom ] && grep -q /etc/X11/gdm $custom ; then
   sed -i -e 's@/etc/X11/gdm@/etc/gdm@g' $custom
fi

%systemd_post gdm.service

%preun
%systemd_preun gdm.service

%postun
%systemd_postun gdm.service

%files -f gdm.lang
%license COPYING
%doc AUTHORS NEWS README.md
%dir %{_sysconfdir}/gdm
%config(noreplace) %{_sysconfdir}/gdm/custom.conf
%config %{_sysconfdir}/gdm/Init/*
%config %{_sysconfdir}/gdm/PostLogin/*
%config %{_sysconfdir}/gdm/PreSession/*
%config %{_sysconfdir}/gdm/PostSession/*
%config %{_sysconfdir}/pam.d/gdm-autologin
%config %{_sysconfdir}/pam.d/gdm-password
%config %{_sysconfdir}/pam.d/gdm-smartcard
%config %{_sysconfdir}/pam.d/gdm-fingerprint
%{_sysconfdir}/gdm/Xsession
%{_sysconfdir}/dbus-1/system.d/gdm.conf
%{_sysconfdir}/pam.d/gdm-launch-environment
%dir %{_sysconfdir}/gdm/Init
%dir %{_sysconfdir}/gdm/PreSession
%dir %{_sysconfdir}/gdm/PostSession
%dir %{_sysconfdir}/gdm/PostLogin
%dir %{_sysconfdir}/dconf/db/gdm.d
%dir %{_sysconfdir}/dconf/db/gdm.d/locks
%{_libexecdir}/gdm-host-chooser
%{_libexecdir}/gdm-runtime-config
%{_libexecdir}/gdm-session-worker
%{_libexecdir}/gdm-simple-chooser
%{_libexecdir}/gdm-wayland-session
%{_libexecdir}/gdm-x-session
%{_sbindir}/gdm
%{_bindir}/gdmflexiserver
%{_bindir}/gdm-screenshot
%{_datadir}/gdm/gdm.schemas
%{_datadir}/glib-2.0/schemas/org.gnome.login-screen.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.login-screen.gschema.override
%dir %{_datadir}/dconf
%dir %{_datadir}/dconf/profile
%{_datadir}/dconf/profile/gdm
%dir %{_datadir}/gdm/greeter
%dir %{_datadir}/gdm/greeter/applications
%{_datadir}/gdm/greeter/applications/*
%dir %{_datadir}/gdm/greeter/autostart
%{_datadir}/gdm/greeter/autostart/*
%{_datadir}/gdm/greeter-dconf-defaults
%{_datadir}/gdm/locale.alias
%{_datadir}/gdm/gdb-cmd
%{_datadir}/gnome-session/sessions/gnome-login.session
%{_libdir}/girepository-1.0/Gdm-1.0.typelib
%{_libdir}/security/pam_gdm.so
%{_libdir}/libgdm*.so*
%dir %{_localstatedir}/log/gdm
%attr(1770, gdm, gdm) %dir %{_localstatedir}/lib/gdm
%attr(0700, gdm, gdm) %dir %{_localstatedir}/lib/gdm/.config
%attr(0700, gdm, gdm) %dir %{_localstatedir}/lib/gdm/.config/pulse
%attr(0600, gdm, gdm) %{_localstatedir}/lib/gdm/.config/pulse/default.pa
%attr(0711, root, gdm) %dir /run/gdm
%{_udevrulesdir}/61-gdm.rules
%{_unitdir}/gdm.service
%dir %{_userunitdir}/gnome-session@gnome-login.target.d/
%{_userunitdir}/gnome-session@gnome-login.target.d/session.conf
%{_sysusersdir}/%{name}.conf

%files devel
%dir %{_includedir}/gdm
%{_includedir}/gdm/*.h
%exclude %{_includedir}/gdm/gdm-pam-extensions.h
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/Gdm-1.0.gir
%{_libdir}/pkgconfig/gdm.pc

%files pam-extensions-devel
%{_includedir}/gdm/gdm-pam-extensions.h
%{_libdir}/pkgconfig/gdm-pam-extensions.pc

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 41.3-7
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 41.3-6
- Rebuilt for OpenCloudOS Stream 23.09

* Mon May 15 2023 Xiaojie Chen <jackxjchen@tencent.com> - 41.3-5
- Remove pam_console.so from the PAM configuration files

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 41.3-4
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 04 2023 Xiaojie Chen <jackxjchen@tencent.com> - 41.3-3
- Add pam config files for OpenCloudOS

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 41.3-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 12 2022 Shuo Wang <abushwang@tencent.com> - 41.3-1
- initial build
